import java.awt.*;
import javax.swing.*;
import alice.logictuple.*;
import alice.tucson.api.*;
import java.lang.*;
import alice.tuprolog.*;
import java.io.*;

public class Beach {	
	public static void main(String[] args) throws Exception {
		
		// apro il contesto Tucson di Default
		TucsonContext omaha=Tucson.enterDefaultContext();

		// apro il TupleCenter beach 
		TupleCentreId beach = new TupleCentreId("beach");
		
		// importo le condizioni di controllo e coordinazione dal file respect per il centro di tuple beach
		TextFileRead read1=new TextFileRead();
		String respectBeach=read1.readTextFile("../respect/beach.rsp");
		
		//setto le specifiche di Respect
		omaha.setSpec(beach, respectBeach);
		
		//Inizializzazione Agente Battlefield addetto alla costruzione della mappa
		AgentId init = new AgentId("battle");
		new Battlefield(init).spawn();		
		
	}
}// fine classe