import java.awt.*;
import javax.swing.*;
import alice.logictuple.*;
import alice.tucson.api.*;
import java.lang.*;
import alice.tuprolog.*;
import java.io.*;
import java.lang.Object.*;
import java.util.*;

public class Private extends alice.tucson.api.Agent {
	
	// inizializzo le variabili
	int idPr=0;
	int time=1000;	
	
	//costruttore di default
	public Private(AgentId aid) throws TucsonException {
   		super(aid);
	} 
	
	//costruttore con inserimento dell id e della velocit
	public Private(AgentId aid, int id, int delay) throws TucsonException {
	   	super(aid);	   	
		this.idPr=id;
		this.time=delay;
	}
	
	public void body(){
		try {
			// apro il contesto Tucson di Default
			TucsonContext omaha=Tucson.enterDefaultContext();

			// apro il TupleCenter beach 
			TupleCentreId beach = new TupleCentreId("beach");
			
			//inizializzo le variabili
			Random r=new Random();
			int pX=r.nextInt(50);
			int pY=0;
			int pH=100;
			
			Value pX1=new Value(pX);
			Value pY1=new Value(pY);
			Value pH1=new Value(pH);
			Value idPr1=new Value(idPr);
			
			int[][] map = new int[70][2];
			int A, B;
			int dead=0;
			int goal=0;
			int wrong=0;
			int direction=0;
			int s=0;
			int out=0;
			Value out1= new Value(out);		
			
			// il soldato impara dove sono dislocati i ripari sulla mappa
			LogicTuple whereShelter;
			for (int i=0;i<70;i++) {
				whereShelter=omaha.in(beach,new LogicTuple("Shelter",new alice.logictuple.Var("X"),new alice.logictuple.Var("Y")));
				A=whereShelter.getArg(0).intValue();
				B=whereShelter.getArg(1).intValue();
				map[i][0]=A;
				map[i][1]=B;
				Value A1=new Value(A);				
				Value B1=new Value(B);
				LogicTuple shelter=new LogicTuple("Shelter",A1,B1);
				omaha.out(beach,shelter);
			} // fine for
			
			
			LogicTuple start=new LogicTuple("Private",idPr1,pX1,pY1,pH1);
			omaha.out(beach,start);
			System.out.println("Private " +idPr+ " is starting at: (" +pX +","+pY +"). Health: " +pH+".");
			
			LogicTuple deadN=new LogicTuple("Dead",idPr1,out1);
			omaha.out(beach,deadN);
			LogicTuple goalN=new LogicTuple("Goal",idPr1,out1);
			omaha.out(beach,goalN);
			
			// movimento del soldato
			do {
				
				
				
				
			//inserisco una pausa per ogni movimento del soldato
				Thread.sleep(time);
				
			// leggo la posizione e la salute attuali dal Tuple Centre
				LogicTuple old=new LogicTuple("Private",idPr1,new alice.logictuple.Var("X"),new alice.logictuple.Var("Y"),new alice.logictuple.Var("Z"));
				omaha.in(beach,old);					
				int oldX = old.getArg(1).intValue();
				int oldY = old.getArg(2).intValue();	
				int oldH = old.getArg(3).intValue();
				Value oldX1 = new Value(oldX);
				Value oldY1 = new Value(oldY);
				Value oldH1 = new Value(oldH);
				
				
				if (oldH==0){
					int d=1;
					Value d1 = new Value(d);
					Thread.sleep(time);
					System.out.println("Private " +idPr+ " is dead.");
					LogicTuple deadR=new LogicTuple("Dead",idPr1,d1);
					omaha.out(beach,deadR);
					out=1;
					
				}
				
				else{
					
					if (oldY==20){
						int g=1;
						Value g1 = new Value(g);
						Thread.sleep(time);
						System.out.println("Private " +idPr+ " has caught up the bunker!");
						LogicTuple goalR=new LogicTuple("Goal",idPr1,g1);
						omaha.out(beach,goalR);
						out=1;
					}
					
					else{
						
						if (oldH!=pH){
							System.out.println("Private " +idPr+ " has been hit but he is still alive!");
						}
						
						
						// se il soldato si muove in avanti			
					if(direction==0){
								
			// aggiorno la posizione attuale incrementando le Y
						pX=oldX;
						pY=oldY+1;
						pH=oldH;
						
			// controllo se la nuova posizione coincide con quella di un riparo
						for (int j=0;j<70;j++) {
							if (pX==map[j][0] && pY==map[j][1]){
								wrong=1;
							}	
						}
						
			// se la nuova posizione coincide con quella di un riparo
						if (wrong==1){
							System.out.println("Private " +idPr+ " is behind a shelter.");
							
			// torno indietro
							pY=oldY;								
	
			// decido in maniera random se andare verso il fianco destro o sinistro
							Random rD=new Random();
							direction= 1 + rD.nextInt(2);
										
							if (direction==1){
								System.out.println("Private " +idPr+ " moves towards right flank.");
							}
							if (direction==2){
								System.out.println("Private " +idPr+ " moves towards left flank.");
							}
						}
			// altrimenti se la nuova posizione  libera avanzo
						else{	
							System.out.println("Private " +idPr+ " moves forward.");
							System.out.println("Private " +idPr+ " is standing at: (" +pX +","+pY +"). Health: " +pH+".");
						}
							
						wrong=0;
						
			// aggiorno la mia posizione e i miei punti vita 
						pX1 = new Value(pX);
						pY1 = new Value(pY);
						pH1 = new Value(pH);					
										
			// aggiorno la mia posizione e i miei punti vita sul TupleCenter				
						LogicTuple curr=new LogicTuple("Private",idPr1,pX1,pY1,pH1);
						omaha.out(beach,curr);	
												
						} // fine direction=0	
					
			// se il soldato si muove verso destra
						else if(direction==1){	
								
			// aggiorno la posizione attuale incrementando le X
							pY=oldY;
							pX=oldX+1;
							pH=oldH;
						
			// controllo se la nuova posizione coincide con quella di un riparo
							for (int j=0;j<70;j++) {
								if (pX==map[j][0] && pY==map[j][1]){
									wrong=1;
								}	
							}
						
			// se la nuova posizione coincide con quella di un riparo
							if (wrong==1){
								System.out.println("Private " +idPr+ " is behind a shelter.");
							
			// vado verso sinistra
								pX=oldX;																		
								direction=2;
								System.out.println("Private " +idPr+ " moves towards left flank.");
				
							}
			// altrimenti se la nuova posizione  libera avanzo
							else{
								direction=0;	
								System.out.println("Private " +idPr+ " is standing at: (" +pX +","+pY +"). Health: " +pH+".");
							}
						
							wrong=0;
							
			// aggiorno la mia posizione e i miei punti vita 
						pX1 = new Value(pX);
						pY1 = new Value(pY);
						pH1 = new Value(pH);					
										
			// aggiorno la mia posizione e i miei punti vita sul TupleCenter				
						LogicTuple curr=new LogicTuple("Private",idPr1,pX1,pY1,pH1);
						omaha.out(beach,curr);	
							
						} // fine direction=1	
						
			// se il soldato si muove verso sinistra
						else if(direction==2){			
						
			// aggiorno la posizione attuale decrementando le X
							pX=oldX-1;
							pY=oldY;
							pH=oldH;
						
			// controllo se la nuova posizione coincide con quella di un riparo
							for (int j=0;j<70;j++) {
								if (pX==map[j][0] && pY==map[j][1]){
									wrong=1;
								}	
							}
						
			// se la nuova posizione coincide con quella di un riparo
							if (wrong==1){
								System.out.println("Private " +idPr+ " is behind a shelter.");
									
			// vado verso destra
								pX=oldX;
								direction=1;
								System.out.println("Private " +idPr+ " moves towards right flank.");
									
							}
						
			// altrimenti se la nuova posizione  libera avanzo
							else{
								direction=0;
								System.out.println("Private " +idPr+ " is standing at: (" +pX +","+pY +"). Health: " +pH+".");
							}
						
							wrong=0;
							
			// aggiorno la mia posizione e i miei punti vita 
						pX1 = new Value(pX);
						pY1 = new Value(pY);
						pH1 = new Value(pH);					
										
			// aggiorno la mia posizione e i miei punti vita sul TupleCenter				
						LogicTuple curr=new LogicTuple("Private",idPr1,pX1,pY1,pH1);
						omaha.out(beach,curr);		
						
						} // fine direction2	
						
						out=0;
					} // fine else di if oldY==20
					
					
					
				} // fine else di if oldH==0
				
			
				
			
				
			} // fine do
			while (out!=1);
			
		}// fine try
		
		catch(Exception ex){
			System.out.println("Something has gone wrong in Private.java...");	
		} // fine catch
	
	
	}// fine body
	
	
}// fine classe