import java.awt.*;
import javax.swing.*;
import alice.logictuple.*;
import alice.tucson.api.*;
import java.lang.*;
import alice.tuprolog.*;
import java.io.*;
import java.lang.Object.*;
import java.util.*;

public class RemoveShelter extends alice.tucson.api.Agent {
	
	// costruttore di default
	public RemoveShelter(AgentId aid) throws TucsonException {
   		super(aid);
   	} // fine costruttore di default
   	
	public void body(){
		
		try {
			// apro il contesto Tucson di Default
			TucsonContext omaha=Tucson.enterDefaultContext();

			// apro il TupleCenter beach 
			TupleCentreId beach = new TupleCentreId("beach");
			
			// inserisco le dimensioni del campo di battaglia
			int dimX=50;
			int dimY=20;
			Value dimX1=new Value(dimX);
			Value dimY1=new Value(dimY);			
			LogicTuple dimentions=new LogicTuple("Dimensions",new alice.logictuple.Var("X"),new alice.logictuple.Var("Y"));    
			omaha.in(beach,dimentions);
			
			// rimuovo le posizioni degli 80 ripari
			for (int i=0; i<52; i++) {
				Random rX=new Random();
				Random rY=new Random();				
				int sX=2+rX.nextInt(45);
				int sY=1+rY.nextInt(18);				
				Value sX1=new Value(sX);
				Value sY1=new Value(sY);				
				LogicTuple shelter=new LogicTuple("Shelter",new alice.logictuple.Var("X"),new alice.logictuple.Var("Y"));    
				omaha.in(beach,shelter);				
			} // fine for	
			
			// inserisco la tupla per la terminazione
			int dead=1;
			Value dead1=new Value(dead);			
			LogicTuple deadT=new LogicTuple("All_dead",dead1);    
			omaha.out(beach,deadT);		
			
			Thread.sleep(3000);
		
			for (int i=0; i<20; i++) {				
				LogicTuple fir=new LogicTuple("Fire",new alice.logictuple.Var("X"),new alice.logictuple.Var("Y"),new alice.logictuple.Var("W"),new alice.logictuple.Var("Z"));    
				omaha.in(beach,fir);				
			} // fine for
		
			
		} // fine try
		catch(Exception ex){
			System.out.println("Something goes wrong in RemoveShelter.java...");	
		} // fine catch
	} // fine body()
	
} //fine classe RemoveShelter