import java.awt.*;
import javax.swing.*;
import alice.logictuple.*;
import alice.tucson.api.*;
import java.lang.*;
import alice.tuprolog.*;
import java.io.*;
import java.lang.Object.*;
import java.util.*;

public class Battlefield extends alice.tucson.api.Agent {
	
	// costruttore di default
	public Battlefield(AgentId aid) throws TucsonException {
   		super(aid);
   	} // fine costruttore di default
   	
	public void body(){
		
		try {
			// apro il contesto Tucson di Default
			TucsonContext omaha=Tucson.enterDefaultContext();

			// apro il TupleCenter beach 
			TupleCentreId beach = new TupleCentreId("beach");
			
			// inserisco le dimensioni del campo di battaglia
			int dimX=50;
			int dimY=20;
			Value dimX1=new Value(dimX);
			Value dimY1=new Value(dimY);			
			LogicTuple dimentions=new LogicTuple("Dimensions",dimX1,dimY1);    
			omaha.out(beach,dimentions);
			
			//adesso  commentato l'inserimento random dei ripari.
		/*	
			// inserisco le posizioni dei 52 ripari
			for (int i=0; i<52; i++) {
				Random rX=new Random();
				Random rY=new Random();				
				int sX=2+rX.nextInt(50);
				int sY=1+rY.nextInt(20);				
				Value sX1=new Value(sX);
				Value sY1=new Value(sY);				
				LogicTuple shelter=new LogicTuple("Shelter",sX1,sY1);    
				omaha.out(beach,shelter);				
			} // fine for	
			
			
		*/	 
		
		//per attivare l'inserimento random dei ripari commentare da qui 
			 int r1x=1;
			 int r1y=1;
			 int r2x=2;
			 int r2y=6;
			 int r3x=3;
			 int r3y=11;
			 int r4x=4;
			 int r4y=4;
			 int r5x=5;
			 int r5y=7;
			 
			 int r6x=6;
			 int r6y=12;
			 int r7x=7;
			 int r7y=3;
			 int r8x=8;
			 int r8y=8;
			 int r9x=9;
			 int r9y=13;
			 int r10x=10;
			 int r10y=4;
			 
			 int r11x=11;			 
			 int r11y=9;
			 int r12x=12;
			 int r12y=14;
			 int r13x=13;
			 int r13y=5;
			 int r14x=14;
			 int r14y=10;
			 int r15x=15;
			 int r15y=15;
			 
			 int r16x=16;
			 int r16y=6;
			 int r17x=17;
			 int r17y=11;
			 int r18x=18;
			 int r18y=16;
			 int r19x=19;
			 int r19y=7;
			 int r20x=20;
			 int r20y=12;
			 
			 int r21x=21;
			 int r21y=17;
			 int r22x=22;
			 int r22y=8;
			 int r23x=23;
			 int r23y=13;
			 int r24x=24;
			 int r24y=18;
			 int r25x=25;			 
			 int r25y=9;
			 
			 int r26x=26;
			 int r26y=14;
			 int r27x=27;
			 int r27y=5;
			 int r28x=28;
			 int r28y=10;
			 int r29x=29;
			 int r29y=15;
			 int r30x=30;
			 int r30y=6;
			 
			 int r31x=31;
			 int r31y=11;
			 int r32x=32;
			 int r32y=16;
			 int r33x=33;
			 int r33y=7;
			 int r34x=34;
			 int r34y=12;
			 int r35x=35;
			 int r35y=17;
			 
			 int r36x=36;
			 int r36y=8;
			 int r37x=37;
			 int r37y=13;
			 int r38x=38;
			 int r38y=18;
			 int r39x=39;
			 int r39y=9;
			 int r40x=40;
			 int r40y=14;
			 
			 int r41x=24;
			 int r41y=3;
			 int r42x=42;
			 int r42y=10;
			 int r43x=43;
			 int r43y=15;
			 int r44x=21;
			 int r44y=2;			 
			 int r45x=45;
			 int r45y=11;
			 
			 int r46x=46;
			 int r46y=16;
			 int r47x=18;
			 int r47y=1;
			 int r48x=48;
			 int r48y=12;
			 int r49x=38;
			 int r49y=2;
			 int r50x=41;
			 int r50y=3;
			 
			 int r51x=44;
			 int r51y=4;
			 int r52x=47;
			 int r52y=5;
			 
			 Value r1x1=new Value(r1x);
			 Value r1y1=new Value(r1y);
			 Value r2x1=new Value(r2x);
			 Value r2y1=new Value(r2y);
			 Value r3x1=new Value(r3x);
			 Value r3y1=new Value(r3y);
			 Value r4x1=new Value(r4x);
			 Value r4y1=new Value(r4y);
			 Value r5x1=new Value(r5x);
			 Value r5y1=new Value(r5y);
			 Value r6x1=new Value(r6x);
			 Value r6y1=new Value(r6y);
			 Value r7x1=new Value(r7x);
			 Value r7y1=new Value(r7y);
			 Value r8x1=new Value(r8x);
			 Value r8y1=new Value(r8y);
			 Value r9x1=new Value(r9x);
			 Value r9y1=new Value(r9y);
			 Value r10x1=new Value(r10x);
			 Value r10y1=new Value(r10y);			 
			 Value r11x1=new Value(r11x);
			 Value r11y1=new Value(r11y);
			 Value r12x1=new Value(r12x);
			 Value r12y1=new Value(r12y);
			 Value r13x1=new Value(r13x);
			 Value r13y1=new Value(r13y);
			 Value r14x1=new Value(r14x);
			 Value r14y1=new Value(r14y);
			 Value r15x1=new Value(r15x);
			 Value r15y1=new Value(r15y);
			 Value r16x1=new Value(r16x);
			 Value r16y1=new Value(r16y);
			 Value r17x1=new Value(r17x);
			 Value r17y1=new Value(r17y);
			 Value r18x1=new Value(r18x);
			 Value r18y1=new Value(r18y);
			 Value r19x1=new Value(r19x);
			 Value r19y1=new Value(r19y);
			 Value r20x1=new Value(r20x);
			 Value r20y1=new Value(r20y);			 
			 Value r21x1=new Value(r21x);
			 Value r21y1=new Value(r21y);
			 Value r22x1=new Value(r22x);
			 Value r22y1=new Value(r22y);
			 Value r23x1=new Value(r23x);
			 Value r23y1=new Value(r23y);
			 Value r24x1=new Value(r24x);
			 Value r24y1=new Value(r24y);
			 Value r25x1=new Value(r25x);
			 Value r25y1=new Value(r25y);
			 Value r26x1=new Value(r26x);
			 Value r26y1=new Value(r26y);
			 Value r27x1=new Value(r27x);
			 Value r27y1=new Value(r27y);
			 Value r28x1=new Value(r28x);
			 Value r28y1=new Value(r28y);
			 Value r29x1=new Value(r29x);
			 Value r29y1=new Value(r29y);
			 Value r30x1=new Value(r30x);
			 Value r30y1=new Value(r30y);
			 Value r31x1=new Value(r31x);
			 Value r31y1=new Value(r31y);
			 Value r32x1=new Value(r32x);
			 Value r32y1=new Value(r32y);
			 Value r33x1=new Value(r33x);
			 Value r33y1=new Value(r33y);
			 Value r34x1=new Value(r34x);
			 Value r34y1=new Value(r34y);
			 Value r35x1=new Value(r35x);
			 Value r35y1=new Value(r35y);
			 Value r36x1=new Value(r36x);
			 Value r36y1=new Value(r36y);
			 Value r37x1=new Value(r37x);
			 Value r37y1=new Value(r37y);
			 Value r38x1=new Value(r38x);
			 Value r38y1=new Value(r38y);
			 Value r39x1=new Value(r39x);
			 Value r39y1=new Value(r39y);
			 Value r40x1=new Value(r40x);
			 Value r40y1=new Value(r40y);
			 Value r41x1=new Value(r41x);
			 Value r41y1=new Value(r41y);
			 Value r42x1=new Value(r42x);
			 Value r42y1=new Value(r42y);
			 Value r43x1=new Value(r43x);
			 Value r43y1=new Value(r43y);
			 Value r44x1=new Value(r44x);
			 Value r44y1=new Value(r44y);
			 Value r45x1=new Value(r45x);
			 Value r45y1=new Value(r45y);
			 Value r46x1=new Value(r46x);
			 Value r46y1=new Value(r46y);
			 Value r47x1=new Value(r47x);
			 Value r47y1=new Value(r47y);
			 Value r48x1=new Value(r48x);
			 Value r48y1=new Value(r48y);
			 Value r49x1=new Value(r49x);
			 Value r49y1=new Value(r49y);
			 Value r50x1=new Value(r50x);
			 Value r50y1=new Value(r50y);
			 Value r51x1=new Value(r51x);
			 Value r51y1=new Value(r51y);
			 Value r52x1=new Value(r52x);
			 Value r52y1=new Value(r52y);
	
		 	LogicTuple shelter1=new LogicTuple("Shelter",r1x1,r1y1);
		 	LogicTuple shelter2=new LogicTuple("Shelter",r2x1,r2y1); 
		 	LogicTuple shelter3=new LogicTuple("Shelter",r3x1,r3y1);
		 	LogicTuple shelter4=new LogicTuple("Shelter",r4x1,r4y1);
		 	LogicTuple shelter5=new LogicTuple("Shelter",r5x1,r5y1);
		 	LogicTuple shelter6=new LogicTuple("Shelter",r6x1,r6y1);
		 	LogicTuple shelter7=new LogicTuple("Shelter",r7x1,r7y1);
		 	LogicTuple shelter8=new LogicTuple("Shelter",r8x1,r8y1);
		 	LogicTuple shelter9=new LogicTuple("Shelter",r9x1,r9y1);
		 	LogicTuple shelter10=new LogicTuple("Shelter",r10x1,r10y1);
		 	LogicTuple shelter11=new LogicTuple("Shelter",r11x1,r11y1);
		 	LogicTuple shelter12=new LogicTuple("Shelter",r12x1,r12y1); 
		 	LogicTuple shelter13=new LogicTuple("Shelter",r13x1,r13y1);
		 	LogicTuple shelter14=new LogicTuple("Shelter",r14x1,r14y1);
		 	LogicTuple shelter15=new LogicTuple("Shelter",r15x1,r15y1);
		 	LogicTuple shelter16=new LogicTuple("Shelter",r16x1,r16y1);
		 	LogicTuple shelter17=new LogicTuple("Shelter",r17x1,r17y1);
		 	LogicTuple shelter18=new LogicTuple("Shelter",r18x1,r18y1);
		 	LogicTuple shelter19=new LogicTuple("Shelter",r19x1,r19y1);
		 	LogicTuple shelter20=new LogicTuple("Shelter",r20x1,r20y1);
		 	LogicTuple shelter21=new LogicTuple("Shelter",r21x1,r21y1);
		 	LogicTuple shelter22=new LogicTuple("Shelter",r22x1,r22y1); 
		 	LogicTuple shelter23=new LogicTuple("Shelter",r23x1,r23y1);
		 	LogicTuple shelter24=new LogicTuple("Shelter",r24x1,r24y1);
		 	LogicTuple shelter25=new LogicTuple("Shelter",r25x1,r25y1);
		 	LogicTuple shelter26=new LogicTuple("Shelter",r26x1,r26y1);
		 	LogicTuple shelter27=new LogicTuple("Shelter",r27x1,r27y1);
		 	LogicTuple shelter28=new LogicTuple("Shelter",r28x1,r28y1);
		 	LogicTuple shelter29=new LogicTuple("Shelter",r29x1,r29y1);
		 	LogicTuple shelter30=new LogicTuple("Shelter",r30x1,r30y1);
		 	LogicTuple shelter31=new LogicTuple("Shelter",r31x1,r31y1);
		 	LogicTuple shelter32=new LogicTuple("Shelter",r32x1,r32y1); 
		 	LogicTuple shelter33=new LogicTuple("Shelter",r33x1,r33y1);
		 	LogicTuple shelter34=new LogicTuple("Shelter",r34x1,r34y1);
		 	LogicTuple shelter35=new LogicTuple("Shelter",r35x1,r35y1);
		 	LogicTuple shelter36=new LogicTuple("Shelter",r36x1,r36y1);
		 	LogicTuple shelter37=new LogicTuple("Shelter",r37x1,r37y1);
		 	LogicTuple shelter38=new LogicTuple("Shelter",r38x1,r38y1);
		 	LogicTuple shelter39=new LogicTuple("Shelter",r39x1,r39y1);
		 	LogicTuple shelter40=new LogicTuple("Shelter",r40x1,r40y1);
		 	LogicTuple shelter41=new LogicTuple("Shelter",r41x1,r41y1);
		 	LogicTuple shelter42=new LogicTuple("Shelter",r42x1,r42y1); 
		 	LogicTuple shelter43=new LogicTuple("Shelter",r43x1,r43y1);
		 	LogicTuple shelter44=new LogicTuple("Shelter",r44x1,r44y1);
		 	LogicTuple shelter45=new LogicTuple("Shelter",r45x1,r45y1);
		 	LogicTuple shelter46=new LogicTuple("Shelter",r46x1,r46y1);
		 	LogicTuple shelter47=new LogicTuple("Shelter",r47x1,r47y1);
		 	LogicTuple shelter48=new LogicTuple("Shelter",r48x1,r48y1);
		 	LogicTuple shelter49=new LogicTuple("Shelter",r49x1,r49y1);
		 	LogicTuple shelter50=new LogicTuple("Shelter",r50x1,r50y1);
		 	LogicTuple shelter51=new LogicTuple("Shelter",r51x1,r51y1);
		 	LogicTuple shelter52=new LogicTuple("Shelter",r52x1,r52y1); 
		 	
			omaha.out(beach,shelter1); 
			omaha.out(beach,shelter2); 
			omaha.out(beach,shelter3); 
			omaha.out(beach,shelter4);
			omaha.out(beach,shelter5); 
			omaha.out(beach,shelter6);
			omaha.out(beach,shelter7); 
			omaha.out(beach,shelter8);
			omaha.out(beach,shelter9); 
			omaha.out(beach,shelter10); 
			omaha.out(beach,shelter11); 
			omaha.out(beach,shelter12); 
			omaha.out(beach,shelter13); 
			omaha.out(beach,shelter14);
			omaha.out(beach,shelter15); 
			omaha.out(beach,shelter16);
			omaha.out(beach,shelter17); 
			omaha.out(beach,shelter18);
			omaha.out(beach,shelter19); 
			omaha.out(beach,shelter20);
			omaha.out(beach,shelter21); 
			omaha.out(beach,shelter22); 
			omaha.out(beach,shelter23); 
			omaha.out(beach,shelter24);
			omaha.out(beach,shelter25); 
			omaha.out(beach,shelter26);
			omaha.out(beach,shelter27); 
			omaha.out(beach,shelter28);
			omaha.out(beach,shelter29); 
			omaha.out(beach,shelter30);
			omaha.out(beach,shelter31); 
			omaha.out(beach,shelter32); 
			omaha.out(beach,shelter33); 
			omaha.out(beach,shelter34);
			omaha.out(beach,shelter35); 
			omaha.out(beach,shelter36);
			omaha.out(beach,shelter37); 
			omaha.out(beach,shelter38);
			omaha.out(beach,shelter39); 
			omaha.out(beach,shelter40);
			omaha.out(beach,shelter41); 
			omaha.out(beach,shelter42); 
			omaha.out(beach,shelter43); 
			omaha.out(beach,shelter44);
			omaha.out(beach,shelter45); 
			omaha.out(beach,shelter46);
			omaha.out(beach,shelter47); 
			omaha.out(beach,shelter48);
			omaha.out(beach,shelter49); 
			omaha.out(beach,shelter50);
			omaha.out(beach,shelter51); 
			omaha.out(beach,shelter52); 
		
			 
	/////////////////////////////////////////////////////////// a qui		
			
			
			
			// inserisco la tupla per la terminazione
			int dead=0;
			Value dead1=new Value(dead);			
			LogicTuple deadT=new LogicTuple("All_dead",dead1);    
			omaha.out(beach,deadT);		
			
		} // fine try
		catch(Exception ex){
			System.out.println("Something goes wrong in Battlefield.java...");	
		} // fine catch
	} // fine body()
	
} //fine classe Battlefield