import java.awt.*;
import javax.swing.*;
import alice.logictuple.*;
import alice.tucson.api.*;
import java.lang.*;
import alice.tuprolog.*;
import java.io.*;
import java.lang.Object.*;
import java.util.*;

public class Fire extends alice.tucson.api.Agent {
	
	// inizializzo le variabili
	int time=4000;	
	
	//costruttore di default
	public Fire(AgentId aid) throws TucsonException {
   		super(aid);
	} 
	
	//costruttore con inserimento della velocit
	public Fire(AgentId aid, int delay) throws TucsonException {
	   	super(aid);	   	
		this.time=delay;
	}
	
	public void body(){
		
		try {
			// apro il contesto Tucson di Default
			TucsonContext omaha=Tucson.enterDefaultContext();

			// apro il TupleCenter beach 
			TupleCentreId beach = new TupleCentreId("beach");
			
			//inizializzo le variabili
			Random rX=new Random();
			Random rY=new Random();
			int fX=rX.nextInt(50);
			int fY=rY.nextInt(20);
			int fD=0;
			
			Value fX1=new Value(fX);
			Value fY1=new Value(fY);
			Value fD1=new Value(fD);
			
			int out=0;
			
			System.out.println("Fire is starting at: (" +fX +","+fY +"). Damage: " +fD+".");
			
			for(int k=1;k<21;k++){
				Value k1=new Value(k);
				LogicTuple start=new LogicTuple("Fire",k1,fX1,fY1,fD1);
				omaha.out(beach,start);				
			}
			
			do{
				Thread.sleep(time);
				
				for(int k=1;k<21;k++){
				Thread.sleep(100);
					Value k1=new Value(k);
									
					// elimino la posizione e il danno attuali dal Tuple Centre
					LogicTuple old=new LogicTuple("Fire", k1 , new alice.logictuple.Var("X"), new alice.logictuple.Var("Y"), new alice.logictuple.Var("Z"));
					omaha.in(beach,old);
										
							
					Random nX=new Random();
					Random nY=new Random();
					Random nD=new Random();
					fX=rX.nextInt(50);
					fY=nY.nextInt(20);
					fD=20+nD.nextInt(200);
					fX1=new Value(fX);
					fY1=new Value(fY);
					fD1=new Value(fD);
					
					LogicTuple fire=new LogicTuple("Fire",k1,fX1,fY1,fD1);
					omaha.out(beach,fire);
					//System.out.println("Fire on position: (" +fX +","+fY +"). Damage: " +fD+".");
					
					LogicTuple b = new LogicTuple("All_dead", new alice.logictuple.Var("X"));
					try{
						omaha.rd(beach,b);
						out=b.getArg(0).intValue();
						//omaha.out(beach,b);				
					}
					catch (Exception e){}	
				
				}						
					
			}
			while (out==0);
			
		} //fine try
		catch(Exception ex){
			System.out.println("Something goes wrong in Fire.java...");	
		} // fine catch
			
	} // fine body	
} // fine classe fire