// Reads from a text (*.txt) file and return a String containing the
// content in the text file.
/****************************
**    TextFileRead.java    **
*****************************/
import java.io.*;
import java.lang.*;

public class TextFileRead implements Serializable {

public String readTextFile(String theFileName) {
 String stringToReturn = "";
 try {
  File myFile = new File(theFileName);
  FileInputStream myFileInput = new FileInputStream(theFileName);
  int sizeOfFile = (int)myFile.length();
  byte inputData[] = new byte[sizeOfFile];
// The array inputData:s length is equal to the file length.
  myFileInput.read(inputData, 0, sizeOfFile);
// Read from file and put each byte  in the array inputData.
  myFileInput.close();
  stringToReturn = new String(inputData);
 } catch (IOException exception) {
   System.out.println("I/O error. Program terminated.");
   System.out.println("File damaged or not found. Make sure that the file is in current library");
   System.exit(0);
 } return stringToReturn;
}
}